Bug 156108

Summary: [GTK] Custom elements specification.
Product: WebKit Reporter: Carlos Alberto Lopez Perez <clopez>
Component: DOMAssignee: WebKitGTK+ bugs <bugs-noreply>
Status: RESOLVED FIXED    
Severity: Normal CC: bugs-noreply, caitp, cgarcia, gyuyoung.kim, mcatanzaro, rniwa
Priority: P2    
Version: WebKit Nightly Build   
Hardware: Unspecified   
OS: Unspecified   
Bug Depends on:    
Bug Blocks: 154907    

Description Carlos Alberto Lopez Perez 2016-04-01 06:48:00 PDT
There is an ongoing implementation of the custom elements API <https://www.w3.org/TR/custom-elements/> on bug 154907.

This bug is for tracking the implementation of the GTK+ specific parts of this specification (if any), for enabling it and for testing it.
Comment 1 Ryosuke Niwa 2016-04-01 12:46:22 PDT
I don't think there will be any port specific code needed other than port specific WebKit API to be exposed if any.
Comment 2 Carlos Alberto Lopez Perez 2016-04-04 07:30:30 PDT
(In reply to comment #1)
> I don't think there will be any port specific code needed other than port
> specific WebKit API to be exposed if any.

On the GTK+ port currently running the tests inside fast/custom-elements currently gives the following:

Regressions: Unexpected text-only failures (11)
  fast/custom-elements/Document-createElement.html [ Failure ]
  fast/custom-elements/Document-defineElement.html [ Failure ]
  fast/custom-elements/HTMLElement-constructor.html [ Failure ]
  fast/custom-elements/defined-pseudo-class.html [ Failure ]
  fast/custom-elements/parser/parser-constructs-custom-element-synchronously.html [ Failure ]
  fast/custom-elements/parser/parser-constructs-custom-elements.html [ Failure ]
  fast/custom-elements/parser/parser-fallsback-to-unknown-element.html [ Failure ]
  fast/custom-elements/parser/parser-sets-attributes-and-children.html [ Failure ]
  fast/custom-elements/parser/parser-uses-constructed-element.html [ Failure ]
  fast/custom-elements/upgrading/Node-cloneNode.html [ Failure ]
  fast/custom-elements/upgrading/upgrading-parser-created-element.html [ Failure ]

Regressions: Unexpected image-only failures (1)
  fast/custom-elements/defined-rule.html [ ImageOnlyFailure ]

Regressions: Unexpected timeouts (4)
  fast/custom-elements/attribute-changed-callback.html [ Timeout ]
  fast/custom-elements/lifecycle-callback-timing.html [ Timeout ]
  fast/custom-elements/parser/parser-constructs-custom-element-in-document-write.html [ Timeout ]
  fast/custom-elements/parser/parser-uses-registry-of-owner-document.html [ Timeout ]


On r195087 <http://trac.webkit.org/r195087> you set the the fast/custom-elements as expected to fail for all ports but the Mac one. However, some tests were timing out (instead of failing), this caused unexpected failures on the bots.

So I skipped completely the fast/custom-elements tests on r198993 <http://trac.webkit.org/r198993> for the GTK+ port linking to this bug.

The EFL port did something similar in r198779 <http://trac.webkit.org/r198779>
Comment 3 Michael Catanzaro 2016-10-09 08:35:19 PDT
All tests added in r206838 are failing. I'll skip these too.

Is there a build or runtime flag for custom elements?
Comment 4 Ryosuke Niwa 2016-10-31 15:04:38 PDT
I'm enabling this feature everywhere on https://bugs.webkit.org/show_bug.cgi?id=164242.
Comment 5 Ryosuke Niwa 2016-11-01 21:44:55 PDT
Fixed in https://bugs.webkit.org/show_bug.cgi?id=164242.